/*  
 Date: 10/30/2011
 Author: Honglei Liu <liuhonglei@gmail.com>

 Description: 
 */

#include "Aligner.h"

void Aligner::fillForkRecords(int mi,vector<unsigned>* startPosList)
{
	int mj,unhandledNum;

	unhandledNum=startPosList->size();
	char *check=new char[unhandledNum];
	memset(check,0,unhandledNum);
	while(unhandledNum!=0)
	{
	 	for(unsigned i=0;i<startPosList->size();i++)
		{
		    if(check[i]==1)
                continue;

			mj=mi+startPosList->at(i);
			Score tscore;
			calNoGapCell(mi,mj,tscore);

			if(tscore.M<=0)
			{
				unhandledNum--;
				check[i]=1;
				continue;
			}
			else
			{
				if(tscore.M>=abs(Parameters::gapOpenScore+Parameters::gapExtendScore)+1)
				{
					tscore.M3=tscore.M+Parameters::gapOpenScore+Parameters::gapExtendScore;
					tscore.M=tscore.M3;
					tscore.M1=-1;
					tscore.M2=-1;

					localStore(mi+1,mj,tscore);

					ForkRecord tf={mi,mj,0,0,0};
					forkRecordList.push_back(tf);
					unhandledNum--;
					check[i]=1;
				}
			}
		}
		mi++;
	}
	delete[] check;
}

void Aligner::calMatrixByColumn(int forkRecordStartNum)
{
	unsigned int mi,mj,mjj,columnIntervelPointer;
	pair<unsigned int,unsigned int> rowIntervel, prevRowIntervel;
	unsigned int i=forkRecordStartNum;
	bool isClearTree=false;

	patternTree.ClearTree();

	while(i<forkRecordList.size())
	{
		if(i+1<forkRecordList.size()&&(forkRecordList.at(i+1).bifurcatePosMi==forkRecordList.at(i).bifurcatePosMi))
			isClearTree=false;
		else
			isClearTree=true;

		patternTree.TreeBack2Root();

		mi=forkRecordList.at(i).bifurcatePosMi;
		mj=forkRecordList.at(i).bifurcatePosMj+1;

		prevRowIntervel.first=mi+1;
		prevRowIntervel.second=mi+1;
		columnIntervelPointer=0;
		vector<pair<unsigned int,unsigned int> > tvector;
		columnIntervelList.push_back(tvector);
		columnIntervelList.at(i).push_back(make_pair(mj-1,mj-1));

		while(pattern.IsCharExist(mj)&&patternTree.CheckNode(pattern.GetChar(mj)))
		{
			mjj=forkRecordList.at(patternTree.CurrentNode->forkNum).bifurcatePosMj+patternTree.CurrentDepth;
			rowIntervel=patternTree.CurrentNode->rowIntervel;
			copyColumn(mj,mjj,rowIntervel);

			//if(forkRecordList.at(i).reuseMaxRow<rowIntervel.second)
				//forkRecordList.at(i).reuseMaxRow=rowIntervel.second;

			add2ColumnIntervelList(prevRowIntervel,rowIntervel,i,columnIntervelPointer,mj);
			prevRowIntervel=rowIntervel;

			mj++;
		}

		if(mj==forkRecordList.at(i).bifurcatePosMj+1)
		{
			rowIntervel.first=mi;
			rowIntervel.second=mi+2;
		}
		else
		{
			rowIntervel.second++;

			forkRecordList.at(i).reuseForkNum=patternTree.CurrentNode->forkNum;
			forkRecordList.at(i).reuseDepth=patternTree.CurrentDepth;
		}
		calColumn(mj,rowIntervel);
		add2ColumnIntervelList(prevRowIntervel,rowIntervel,i,columnIntervelPointer,mj);
		prevRowIntervel=rowIntervel;

		while(rowIntervel.first<=rowIntervel.second)
		{
			if(!isClearTree)
				patternTree.Add2Tree(i,pattern.GetChar(mj),rowIntervel);
			mj++;
			rowIntervel.second++;
			calColumn(mj,rowIntervel);
			add2ColumnIntervelList(prevRowIntervel,rowIntervel,i,columnIntervelPointer,mj);
			prevRowIntervel=rowIntervel;
		}

		if(isClearTree)
			patternTree.ClearTree();

		i++;

	}
}

void Aligner::calMatrixByRow()
{
	unsigned int mi=text.RollBack();	//this is the start(this row is included) of the rows that need to be changed

	while(mi>=Parameters::qLen)
	{
		for(unsigned int i=0;i<forkRecordList.size();i++)
		{
		    unsigned int mii=mi;

			int offset=mii-forkRecordList.at(i).bifurcatePosMi-1;
			if(offset<0)
			{
				vector<unsigned>* startPosList=new vector<unsigned>;
				//for(unsigned int ii=i;ii<forkRecordList.size();ii++)
				while(i<forkRecordList.size())
				{
					startPosList->push_back(forkRecordList.back().bifurcatePosMj-forkRecordList.back().bifurcatePosMi);

					columnIntervelList.pop_back();
					forkRecordList.pop_back();
				}
				fillForkRecords(mii,startPosList);
				calMatrixByColumn(i);
				break;
			}
			else
			{
			    /*
			    pair<unsigned int,unsigned int> columnIntervel=columnIntervelList.at(i).at(offset);
				calRowWithReuse(i,mi,columnIntervel);
				while(columnIntervel.first<=columnIntervel.second)
				{
					if(offset>=columnIntervelList.at(i).size())
						columnIntervelList.at(i).push_back(columnIntervel);
					else
						columnIntervelList.at(i).at(offset)=columnIntervel;
					mi++;
					offset++;
					columnIntervel.second++;
					calRowWithReuse(i,mi,columnIntervel);
				}*/

				if(offset>=columnIntervelList.at(i).size())
                    continue;

                while(offset+1<columnIntervelList.at(i).size())
                    columnIntervelList.at(i).pop_back();

				pair<unsigned int,unsigned int> columnIntervel=columnIntervelList.at(i).back();
				columnIntervelList.at(i).pop_back();

				calRowWithReuse(i,mii,columnIntervel);
				while(columnIntervel.first<=columnIntervel.second)
				{
                    columnIntervelList.at(i).push_back(columnIntervel);

					mii++;
					offset++;
					columnIntervel.second++;
					calRowWithReuse(i,mii,columnIntervel);
				}
			}

		}
		mi=text.RollBack();
	}
	columnIntervelList.clear();
	forkRecordList.clear();

}

void Aligner::calRowWithReuse(unsigned int forkNum,unsigned int mi,pair<unsigned int,unsigned int> &columnIntervel)
{
    unsigned int reusenum=forkRecordList.at(forkNum).reuseForkNum;
    unsigned int reuseMaxRow=forkRecordList.at(reusenum).bifurcatePosMi+columnIntervelList.at(reusenum).size();
	
    filteredCellNum+=2;

	if(mi<=reuseMaxRow)
	{
		unsigned int reusebound=forkRecordList.at(reusenum).bifurcatePosMj+forkRecordList.at(forkNum).reuseDepth;
		unsigned int offset=forkRecordList.at(forkNum).bifurcatePosMj-forkRecordList.at(reusenum).bifurcatePosMj;
		unsigned int pointer=mi-forkRecordList.at(forkNum).bifurcatePosMi-1;

		unsigned int i=columnIntervelList.at(reusenum).at(pointer).first;
		unsigned int j=columnIntervelList.at(reusenum).at(pointer).second;

		columnIntervel.first=i+offset;
		if (j<reusebound)
		{
			columnIntervel.second=j+offset;
			copyRow(mi,columnIntervelList.at(reusenum).at(pointer),offset);
		}
		else
		{
		    if(i<=reusebound)
		    {
		        j=reusebound;
                copyRow(mi,make_pair(i,j),offset);

                j+=offset;
                i=j;
                Score tscore;
                while (j<columnIntervel.second)
                {
                    j++;
                    calCell(mi,j,tscore);
                    if (tscore.M>0)
                    {
                        i=j;
                    }
                }
                if(i==columnIntervel.second)
                {
                    calCellFromLeft(mi,i+1,tscore);
                    if (tscore.M>0)
                        i++;
                }
                columnIntervel.second=i;
		    }
		}

		return;
	}


		Score tscore;

		unsigned int i=columnIntervel.first,j;
		j=i;

		calCellFromTop(mi,i,tscore);
		while (tscore.M<=0)
		{
			i++;
			if(i>columnIntervel.second)
				break;
			calCell(mi,i,tscore);
		}
		columnIntervel.first=i;

		while (i<columnIntervel.second)
		{
			i++;
			calCell(mi,i,tscore);
			if (tscore.M>0)
			{
				j=i;
			}
		}

		if(j==columnIntervel.second)
		{
			calCellFromTop(mi,j+1,tscore);
			if(tscore.M>0)
				j++;
		}

		columnIntervel.second=j;

}

void Aligner::localStore(unsigned int mi,unsigned int mj,Score &score)
{
	/*int condition1=Parameters::thresholdH-(pattern.GetLength()-mj)*Parameters::matchScore;
	int condition2=Parameters::thresholdH-(Parameters::Lmax-mi)*Parameters::matchScore;
	if(score.M<condition1||score.M<condition2)
	{
		calculatedCellNum--;
		calculationNum-=3;
		filteredCellNum++;
	}*/

	localMatrix[make_pair(mi,mj)]=score;

	if(score.M>=Parameters::thresholdH)
		globalStore(mi,mj,score);
}

void Aligner::globalStore(unsigned int mi,unsigned int mj, Score &score)
{
	vector<unsigned int> *poslist=text.GetGlobalPosList(mi);

	while (!poslist->empty())
	{
		pair<unsigned int, unsigned int> tp;
		tp.first=poslist->back();
		poslist->pop_back();
		tp.second=mj;

		if (globalMatrix.find(tp) == globalMatrix.end())
		{
			globalMatrix[tp]=make_pair(tp.first-mi,score.M);
		}
		else
		{
			if(globalMatrix[tp].second<score.M)
				globalMatrix[tp]=make_pair(tp.first-mi,score.M);
		}
	}
}

void Aligner::calNoGapCell(unsigned int mi, unsigned int mj,Score &tscore)
{
    calculatedCellNum++;
    nogapCellNum++;
    calculationNum++;

	pair<unsigned int,unsigned int> tp(mi-1,mj-1);
	tscore=localMatrix[tp];

	if (!isCharExist(mi,mj))
	{
		tscore.M=-1;
		return;
	}

	if(isCharEqual(mi,mj))
	{
		tscore.M1=tscore.M+Parameters::matchScore;
	}
	else
	{
		tscore.M1=tscore.M+Parameters::mismatchScore;
	}
	tscore.M=tscore.M1;
	tscore.M2=-1;
	tscore.M3=-1;

	if(tscore.M>0)
		localStore(mi,mj,tscore);
	else
	{
		tp.first=mi;
		tp.second=mj;

		if (localMatrix.find(tp)!=localMatrix.end())
		{
			localMatrix.erase(tp);
		}
	}
}

void Aligner::calCellFromLeft(unsigned int mi, unsigned int mj,Score &tscore)
{
    calculatedCellNum++;
    calculationNum++;

	pair<unsigned int,unsigned int> tp(mi,mj-1);
	tscore=localMatrix[tp];

	if (!isCharExist(mi,mj))
	{
		tscore.M=-1;
		return;
	}

	tscore.M2=max(tscore.M2+Parameters::gapExtendScore,tscore.M+Parameters::gapOpenScore+Parameters::gapExtendScore);

	tscore.M=tscore.M2;
	tscore.M1=-1;
	tscore.M3=-1;

	if(tscore.M>0)
		localStore(mi,mj,tscore);
	else
	{
		tp.first=mi;
		tp.second=mj;

		if (localMatrix.find(tp)!=localMatrix.end())
		{
			localMatrix.erase(tp);
		}
	}
}

void Aligner::calCellFromTop(unsigned int mi,unsigned int mj,Score &tscore)
{
    calculatedCellNum++;
    calculationNum++;

	pair<unsigned int,unsigned int> tp(mi,mj-1);
	tscore=localMatrix[tp];

	if (!isCharExist(mi,mj))
	{
		tscore.M=-1;
		return;
	}

	tscore.M3=max(tscore.M3+Parameters::gapExtendScore,tscore.M+Parameters::gapOpenScore+Parameters::gapExtendScore);

	tscore.M=tscore.M3;
	tscore.M1=-1;
	tscore.M2=-1;

	if(tscore.M>0)
		localStore(mi,mj,tscore);
	else
	{
		tp.first=mi;
		tp.second=mj;

		if (localMatrix.find(tp)!=localMatrix.end())
		{
			localMatrix.erase(tp);
		}
	}
}

void Aligner::calCell(unsigned int mi,unsigned int mj,Score &tscore)
{
    calculatedCellNum++;
    calculationNum+=3;

	int m1,m2,m3;
	pair<unsigned int,unsigned int> tp(mi-1,mj-1);

	if (!isCharExist(mi,mj))
	{
		tscore.M=-1;
		return;
	}

	if (localMatrix.find(tp)!=localMatrix.end())	//from upleft
	{
		tscore=localMatrix[tp];
		if(isCharEqual(mi,mj))
		{
			m1=tscore.M+Parameters::matchScore;
		}
		else
		{
			m1=tscore.M+Parameters::mismatchScore;
		}
	}
	else
	{
		m1=-1;
	}

	tp.first=mi;	//from left
	if (localMatrix.find(tp)!=localMatrix.end())
	{
		tscore=localMatrix[tp];
		m2=max(tscore.M2+Parameters::gapExtendScore,tscore.M+Parameters::gapOpenScore+Parameters::gapExtendScore);
	}
	else
	{
		m2=-1;
	}

	tp.first=mi-1;
	tp.second=mj;	//from top
	if (localMatrix.find(tp)!=localMatrix.end())
	{
		tscore=localMatrix[tp];
		m3=max(tscore.M3+Parameters::gapExtendScore,tscore.M+Parameters::gapOpenScore+Parameters::gapExtendScore);
	}
	else
	{
		m3=-1;
	}

	tscore.M1=m1;
	tscore.M2=m2;
	tscore.M3=m3;

	tscore.M=max(m1,m2,m3);

	if(tscore.M>0)
		localStore(mi,mj,tscore);
	else
	{
		tp.first=mi;
		tp.second=mj;

		if (localMatrix.find(tp)!=localMatrix.end())
		{
			localMatrix.erase(tp);
		}
	}

}

bool Aligner::isCharExist(unsigned int mi,unsigned int mj)
{
	return text.IsCharExist(mi)&&pattern.IsCharExist(mj);
}

bool Aligner::isCharEqual(unsigned int mi,unsigned int mj)
{
	return text.GetChar(mi)==pattern.GetChar(mj);
}

void Aligner::add2ColumnIntervelList(pair<unsigned int,unsigned int> &prevRowIntervel,pair<unsigned int,unsigned int> &rowIntervel,
							unsigned int i,unsigned int &columnIntervelPointer,unsigned int mj)
{
	if(rowIntervel.first<=rowIntervel.second)
	{
		int k=rowIntervel.first-prevRowIntervel.first;

		while(k>0)
		{
			columnIntervelList.at(i).at(columnIntervelPointer).second=mj-1;
			columnIntervelPointer++;
			k--;
		}

		k=rowIntervel.second-prevRowIntervel.second;

		while(k>0)
		{
			columnIntervelList.at(i).push_back(make_pair(mj,mj));
			k--;
		}

	}
	else
	{
		while(columnIntervelPointer<columnIntervelList.at(i).size())
		{
			columnIntervelList.at(i).at(columnIntervelPointer).second=mj-1;
			columnIntervelPointer++;
		}
	}
}


void Aligner::calColumn(unsigned int mj,pair<unsigned int, unsigned int> &rowIntervel)
{
	Score tscore;

	filteredCellNum+=2;

	unsigned int i=rowIntervel.first,j;
	j=i;

	calCellFromLeft(i,mj,tscore);
	while (tscore.M<=0)
	{
		i++;
		if(i>rowIntervel.second)
			break;
		calCell(i,mj,tscore);
	}
	rowIntervel.first=i;

	while (i<rowIntervel.second)
	{
		i++;
		calCell(i,mj,tscore);
		if (tscore.M>0)
		{
			j=i;
		}
	}

	if(j==rowIntervel.second)
	{
		calCellFromTop(j+1,mj,tscore);
		if(tscore.M>0)
			j++;
	}

	rowIntervel.second=j;

}


void Aligner::copyColumn(unsigned int mj,unsigned int mjj,pair<unsigned int,unsigned int> &rowIntervel)
{
	filteredCellNum+=2;

	for (unsigned int mi=rowIntervel.first;mi<=rowIntervel.second;mi++)
	{
		copyCell(mi,mjj,mi,mj);
	}
}

void Aligner::copyRow(unsigned int mi,pair<unsigned int,unsigned int> columnIntervel,unsigned int offset)
{
	filteredCellNum+=2;

	for (unsigned int mj=columnIntervel.first;mj<=columnIntervel.second;mj++)
	{
		copyCell(mi,mj,mi,mj+offset);
	}
}

void Aligner::copyCell(unsigned int mii,unsigned int mjj,unsigned int mi,unsigned int mj)
{
	resuedCellNum++;

	pair<unsigned int,unsigned int> tp1(mii,mjj),tp2(mi,mj);

	if(localMatrix.find(tp1)!=localMatrix.end())
	{
		localMatrix[tp2]=localMatrix[tp1];
	}
	else
	{
		if (localMatrix.find(tp2)!=localMatrix.end())
		{
			localMatrix.erase(tp2);
		}
	}	
}

void Aligner::calParam()
{
	Parameters::qLen=min(abs(Parameters::mismatchScore),abs(Parameters::gapOpenScore+Parameters::gapExtendScore))/Parameters::matchScore+1;
	Parameters::Lmax=max(pattern.GetLength(),pattern.GetLength()+(int)(Parameters::thresholdH-(Parameters::matchScore*pattern.GetLength()+Parameters::gapOpenScore))/Parameters::gapExtendScore);
}

void Aligner::PrintParam()
{
    cout<<endl;
    cout<<"Match Score      : "<<Parameters::matchScore<<endl;
    cout<<"Mismatch Score   : "<<Parameters::mismatchScore<<endl;
    cout<<"Gap Open         : "<<Parameters::gapOpenScore<<endl;
    cout<<"Gap Extension    : "<<Parameters::gapExtendScore<<endl;
    cout<<"Gram Length      : "<<Parameters::qLen<<endl;
    cout<<"Cutoff score     : "<<Parameters::thresholdH<<endl;
    
    cout<<endl;

    cout<<endl;
    cout<<"the number of resued cells              : "<<resuedCellNum<<endl;
    cout<<"the number of calculated cells          : "<<calculatedCellNum<<endl;
    cout<<"the number of cells in no gap region    : "<<nogapCellNum<<endl;
    cout<<"the number of accessed cells            : "<<(resuedCellNum+calculatedCellNum)<<endl;
    cout<<"the number of calculations              : "<<calculationNum<<endl;
    cout<<"the number of forks                     : "<<forkCount<<endl;
    cout<<"the number of filtered forks            : "<<dominateFilteredNum<<endl;
    cout<<"the number of accessed cells in BWT-SW  : "<<(filteredCellNum+nogapCellNum*2+resuedCellNum+calculatedCellNum)<<endl;
    cout<<"the number of calculations in BWT-SW    : "<<(filteredCellNum+nogapCellNum*2+resuedCellNum+calculatedCellNum)*3<<endl;
    cout<<"the ratio of reusing                    : "<<(double)resuedCellNum/(resuedCellNum+calculatedCellNum)<<endl;
    cout<<"the ratio of no gap region              : "<<(double)nogapCellNum/(resuedCellNum+calculatedCellNum)<<endl;
    cout<<"the ratio of filtered forks             : "<<(double)dominateFilteredNum/forkCount<<endl;
    cout<<"the ratio of accessed cells our:bwtsw   : "<<(double)(resuedCellNum+calculatedCellNum)/(filteredCellNum+nogapCellNum*2+resuedCellNum+calculatedCellNum)<<endl;
    cout<<"the ratio of calculated cells our:bwtsw : "<<(double)(calculatedCellNum)/(filteredCellNum+nogapCellNum*2+resuedCellNum+calculatedCellNum)<<endl;
    cout<<"the ratio of calculations our:bwtsw     : "<<(double)calculationNum/((filteredCellNum+nogapCellNum*2+resuedCellNum+calculatedCellNum)*3)<<endl;
    //cout<<"size of local matrix                    : "<<localMatrix.size()<<endl;
    //cout<<"size of global matrix                   : "<<globalMatrix.size()<<endl;
    cout<<"size of bwt index                       : "<<text.GetIndexSize()<<" M"<<endl;
    cout<<endl;
}

void Aligner::Alignment()
{
	int mi,mj;
	string gram;
	Score tscore1,tscore2;

	pattern.CreateInvertedLists();

	while((gram=pattern.GetNextGram())!="")
	{
		if(!text.LocateGram(gram))
			continue;

		mi=Parameters::qLen-1;
		vector<unsigned>* startPosList=pattern.GetGramList(gram);

		tscore1.M1=Parameters::qLen*Parameters::matchScore;
		tscore1.M=tscore1.M1;
		tscore1.M2=-1;
		tscore1.M3=-1;

		tscore2.M3=tscore1.M+Parameters::gapOpenScore+Parameters::gapExtendScore;
		tscore2.M=tscore2.M3;
		tscore2.M1=-1;
		tscore2.M2=-1;

        forkCount+=startPosList->size();
	filteredCellNum+=Parameters::qLen*startPosList->size();

		for(unsigned i=0;i<startPosList->size();i++)
		{
		    if(startPosList->at(i)>0)
		    	{
				string gram_pr=pattern.GetGram(startPosList->at(i)-1);
				if(text.CheckDominate(gram_pr, gram))
				{
				    dominateFilteredNum++;
				    continue;
				}
            		}

			mj=mi+startPosList->at(i);
			localStore(mi,mj,tscore1);

			if(tscore2.M>0)
			{
				localStore(mi+1,mj,tscore2);

				ForkRecord tf={mi,mj,0,0,0};
				forkRecordList.push_back(tf);
			}
		}
		if(tscore2.M<=0)
			fillForkRecords(mi+1,startPosList);
		calMatrixByColumn(0);
		calMatrixByRow();
	}

}

void Aligner::Output(string output_name)
{
	unordered_map<pair<unsigned int,unsigned int>, pair<unsigned int,unsigned int>,pair_hashh,compare_pair>::iterator iter;
	
	ofstream outf(output_name.c_str());  
     	streambuf *strm_buf=cout.rdbuf();     
     	cout.rdbuf(outf.rdbuf());  
    
	for (iter=globalMatrix.begin();iter!=globalMatrix.end();++iter)
	{
		cout<<"Score= "<<iter->second.second<<", End postion in query= "<<iter->first.second<<endl;
		cout<<"Sbjct: "<<iter->second.first<<"-----"<<iter->first.first<<endl;
		cout<<endl;
	}

	cout.rdbuf(strm_buf);   //recover  
}
