/*  
 Date: 10/30/2011
 Author: Honglei Liu <liuhonglei@gmail.com>

 Description: 
 */

#ifndef ALIGNER_INCLUDED
#define ALIGNER_INCLUDED

#include "pattern.h"
#include "Text.h"
#include "Parameters.h"
#include "Tree.h"

#include <utility>
#include <iostream>
#include <fstream>
#include <string.h>
#include <tr1/unordered_map>

using namespace std;
using namespace tr1;

class Aligner
{
public:

	Aligner(string index_name, string &p):text(index_name),pattern(p)
	{
	    calParam();

        resuedCellNum=0;
        calculatedCellNum=0;
        localMatrixSize=0;
        nogapCellNum=0;
        dominateFilteredNum=0;
        forkCount=0;
	filteredCellNum=0;
	calculationNum=0;
	}

	~Aligner()
	{
	}

	void Alignment();

	void Output(string output_name);

	void PrintParam();

private:

    	void calParam();

	void fillForkRecords(int mi,vector<unsigned>* startPosList);

	void calMatrixByColumn(int forkRecordStartNum);

	void calMatrixByRow();

	void calColumn(unsigned int mj,pair<unsigned int, unsigned int> &rowIntervel);

	void calRowWithReuse(unsigned int forkNum,unsigned int mi,pair<unsigned int,unsigned int> &columnIntervel);

	void calNoGapCell(unsigned int mi, unsigned int mj,Score &tscore);

	void calCellFromLeft(unsigned int mi, unsigned int mj,Score &tscore);

	void calCellFromTop(unsigned int mi,unsigned int mj,Score &tscore);

	void calCell(unsigned int mi,unsigned int mj,Score &tscore);

	void copyColumn(unsigned int mj,unsigned int mjj,pair<unsigned int,unsigned int> &rowIntervel);

	void copyRow(unsigned int mi,pair<unsigned int,unsigned int> columnIntervel,unsigned int offset);

	void copyCell(unsigned int mii,unsigned int mjj,unsigned int mi,unsigned int mj);

	void add2ColumnIntervelList(pair<unsigned int,unsigned int> &prevRowIntervel,pair<unsigned int,unsigned int> &rowIntervel,
							unsigned int i,unsigned int &columnIntervelPointer,unsigned int mj);

	void localStore(unsigned int mi,unsigned int mj,Score &score);

	void globalStore(unsigned int mi,unsigned int mj, Score &score);

	bool isCharExist(unsigned int mi,unsigned int mj);

	bool isCharEqual(unsigned int mi,unsigned int mj);

private:
    unsigned int resuedCellNum;
    unsigned int calculatedCellNum;
    unsigned int localMatrixSize;
    unsigned int nogapCellNum;
    unsigned int dominateFilteredNum;
    unsigned int forkCount;
    unsigned int filteredCellNum;
    unsigned int calculationNum;

private:
	vector<ForkRecord> forkRecordList;
	Pattern pattern;
	Text text;
	Tree patternTree;
	vector<vector<pair<unsigned int,unsigned int> > > columnIntervelList;
	unordered_map <pair<unsigned int,unsigned int>, Score,pair_hashh,compare_pair> localMatrix;
	unordered_map <pair<unsigned int,unsigned int>, pair<unsigned int,unsigned int>,pair_hashh,compare_pair> globalMatrix;
};


#endif
