/*  
 Date: 10/30/2011
 Author: Honglei Liu <liuhonglei@gmail.com>
	 Jiaying Wang
	 Zhida Chen

 Description: 
 */

#ifndef _BWT_INCLUDED
#define _BWT_INCLUDED

#include <string>
#include <vector>
#include <utility>

class BWT
{
	public:

		BWT(std::string name);

		~BWT() { delete []bwt; }

		void CalSA(std::string gram,std::pair<unsigned,unsigned>  &sa_range);
		void CalSA(char add_c,std::pair<unsigned int,unsigned int> &prev_sa,std::pair<unsigned int,unsigned int> &new_sa);


		std::vector<unsigned>* GetPosList(std::pair<unsigned,unsigned> &sa_range);

		std::vector<unsigned>* GetPosList(std::string s);

		unsigned GetTextLength()
		{
			return file_len;
		}

		double GetIndexSize()
		{
			double sum=0;
			for(unsigned i=0;i<bucket.size();i++)
				sum+=bucket[i].size()*4;
			sum=sum/(1024*1024);
			sum+=(file_len/4+sa.size()*4+C.size()*4+map.size()*4+remap.size()*4)/(1024*1024);

			return sum;
		}

	private:
		std::string filename;
		std::string sa_filename;
		unsigned file_len;
		std::vector<int> sa;

		std::vector<int> C;
		std::vector<int> map;
		std::vector<int> remap;
		std::vector< std::vector<int> > bucket;

		char *bwt;
	private:
		void init_struc();
		void load_sa_file();
		int build_C_map();
		void build_bucket(const int k);
		unsigned occ(char ch,unsigned k);
};

#endif


