/*  
 Date: 10/30/2011
 Author: Honglei Liu <liuhonglei@gmail.com>

 Description: 
 */

#include "Text.h"

Text::Text(string index_name):bwt(index_name)
{
    //bwt=new BWT(index_name);
    dominatePreProcess(index_name+".dominate");
}

Text::~Text()
{

}

//
//if the gram exists and is located, return true, return false if the gram do not exist
//
bool Text::LocateGram(string gram)
{
	pair<unsigned int,unsigned int> sa;

	bwt.CalSA(gram,sa);
	if(sa.first<sa.second)
	{
		Cache ca={Parameters::GetCharNum(gram.at(Parameters::qLen-1)),sa};
		currentSuffix.clear();
		for (unsigned int i=0;i<Parameters::qLen;i++)
		{
			currentSuffix.push_back(ca);
		}
		return true;
	}
	else
		return false;
}

unsigned int Text::RollBack()
{
	unsigned int currentAlphaNum=currentSuffix.back().alphaNum;
	currentSuffix.pop_back();
	while (currentSuffix.size()>=Parameters::qLen)
	{
		while (++currentAlphaNum<ALPHABETSIZE)
		{
			pair<unsigned int,unsigned int> sa;
			bwt.CalSA(AlphabetSet[currentAlphaNum],currentSuffix.back().SA_range,sa);
			if (sa.first<sa.second)
			{
				Cache ca={currentAlphaNum,sa};
				currentSuffix.push_back(ca);
				break;
			}
		}

		if (currentAlphaNum<ALPHABETSIZE)
			break;
		else
		{
			currentAlphaNum=currentSuffix.back().alphaNum;
			currentSuffix.pop_back();
		}
	}
	return currentSuffix.size()-1;
}

vector<unsigned int>* Text::GetGlobalPosList(unsigned int mi)
{
	pair<unsigned int,unsigned int> sa=currentSuffix.at(mi).SA_range;
	vector<unsigned int>* poslist=bwt.GetPosList(sa);

	return poslist;
}

bool Text::IsCharExist(unsigned int mi)
{
	if (mi>=currentSuffix.size())
	{
		unsigned int currentAlphaNum=0;
		while (currentAlphaNum<ALPHABETSIZE)
		{
			pair<unsigned int,unsigned int> sa;
			bwt.CalSA(AlphabetSet[currentAlphaNum],currentSuffix.back().SA_range,sa);
			if (sa.first<sa.second)
			{
				Cache ca={currentAlphaNum,sa};
				currentSuffix.push_back(ca);
				break;
			}
			currentAlphaNum++;
		}
		if (currentAlphaNum<ALPHABETSIZE)
			return true;
		else
			return false;
	}
	else
		return true;
}

char Text::GetChar(unsigned int mi)
{
	return AlphabetSet[currentSuffix.at(mi).alphaNum];
}
//peitao
bool Text::CheckDominate(const string &gram1, const string &gram2)
{
    	// A-->B
	if
	(
	m_dominateTable.end()
	==
	m_dominateTable.find(pair<unsigned int,unsigned int>(gram2index(gram1),gram2index(gram2)))
	)
	{return false;}
	return true;
}

void Text::dominatePreProcess(const string & filename)
{
    ifstream fin(filename.c_str());
	if (!fin)
	{
		cerr<<"open file\""<<filename<<"\" fail...\n";
	}
	while(fin)
	{
		unsigned int a,b;
		fin>>a;
		fin>>b;
		m_dominateTable.insert(pair<unsigned int,unsigned int>(a,b));
	}
}

int Text::gram2index(const string & gram)
{
	assert(gram.size()==Parameters::qLen);
	int ret=0;
	for (unsigned int i = 0; i < Parameters::qLen; i += 1)
	{
		ret *= ALPHABETSIZE;
		ret +=Parameters::GetCharNum(gram[i]);
	}
	return ret;
}








