/*  
 Date: 10/30/2011
 Author: Honglei Liu <liuhonglei@gmail.com>

 Description: 
 */

#ifndef TEXT_INCLUDED
#define TEXT_INCLUDED
#include <string>
#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <assert.h>
#include <vector>
#include <algorithm>
#include <math.h>
#include <tr1/unordered_set>
#include "BWT.h"
#include "Parameters.h"


using namespace std;

struct Cache
{
	unsigned int alphaNum;
	pair<unsigned int,unsigned int> SA_range;
};
struct pair_hashh1
{
        size_t operator()(const pair<unsigned int,unsigned int> &p) const
        {
                return p.second<<16^p.first;
        }
};

struct compare_pair1
{
	bool operator()(const  pair<unsigned int,unsigned int> &p1, const  pair<unsigned int,unsigned int> &p2) const
	{
		return (p1.first==p2.first && p1.second==p2.second);
	}
};
class Text
{
public:

	Text(string index_name);

	~Text();

	bool LocateGram(string gram);

	unsigned int RollBack();

	vector<unsigned int>* GetGlobalPosList(unsigned int mi);

	bool IsCharExist(unsigned int mi);

	char GetChar(unsigned int mi);

	//return true if gram2 is dominated by gram1, otherwise false
	bool CheckDominate(const string &gram1, const string &gram2);

	double GetIndexSize()
	{
		return bwt.GetIndexSize();
	}

//peitao
	void dominatePreProcess(const string & filename);
	int gram2index(const string & gram);

private:
	vector<Cache> currentSuffix;
	BWT bwt;
	tr1::unordered_set<pair<unsigned int,unsigned int>,pair_hashh1,compare_pair1> m_dominateTable;
};







#endif
