/*  
 Date: 10/30/2011
 Author: Honglei Liu <liuhonglei@gmail.com>

 Description: 
 */

#ifndef TREE_INCLUDED
#define TREE_INCLUDED

#include "Parameters.h"

struct TreeNode
{
	unsigned int forkNum;
	pair<unsigned int,unsigned int> rowIntervel;
	TreeNode* pointer[ALPHABETSIZE];

	TreeNode( )
	{
		for (unsigned int i=0;i<ALPHABETSIZE;i++)
		{
			pointer[i]=NULL;
		}
	}

	TreeNode(unsigned int _forkNum,pair<unsigned int,unsigned int> &_rowIntervel)
	{
		forkNum=_forkNum;
		rowIntervel=_rowIntervel;
		for (unsigned int i=0;i<ALPHABETSIZE;i++)
		{
			pointer[i]=NULL;
		}
	}
};

class Tree
{
public:

	Tree()
	{
		root=new TreeNode();
		CurrentNode=root;
		CurrentDepth=0;
	}

	~Tree(){release(root);}

	void release(TreeNode* releaseNode)
	{
		TreeNode* r;

		if (releaseNode==NULL)
		{
			return;
		}
		else
		{
			for (unsigned int i=0;i<ALPHABETSIZE;i++)
			{
				r=releaseNode->pointer[i];
				release(r);
			}
			delete releaseNode;
		}
	}

	void ClearTree()
	{
		release(root);
		root=new TreeNode();
		CurrentNode=root;
		CurrentDepth=0;
	}

	void TreeBack2Root()
	{
		CurrentNode=root;
		CurrentDepth=0;
	}

	bool CheckNode(char c)
	{
		unsigned int num=Parameters::GetCharNum(c);

		if(CurrentNode->pointer[num]!=NULL)
		{
			CurrentNode=CurrentNode->pointer[num];
			CurrentDepth++;
			return true;
		}
		else
			return false;
	}

	void Add2Tree(unsigned int forkNum,char c,pair<unsigned int,unsigned int> &rowIntervel)
	{
		unsigned int num=Parameters::GetCharNum(c);

		CurrentNode->pointer[num]=new TreeNode(forkNum,rowIntervel);
		CurrentNode=CurrentNode->pointer[num];
		CurrentDepth++;
	}

public:
	TreeNode* CurrentNode;
	unsigned int CurrentDepth;

private:
	TreeNode* root;

};

#endif
