/*  
 Date: 10/30/2011
 Author: Honglei Liu <liuhonglei@gmail.com>

 Description: 
 */


#include "input.h"

void readString(string &data, const string &filenameData)
{
  char c;

  data.clear();

  ifstream fileData(filenameData.c_str(),ios::in);
  if (!fileData) {
    cerr << "can't open input file \"" << filenameData << "\"" << endl;
    exit(EXIT_FAILURE);
  }

  cerr << "reading \"" << filenameData << "\"...";
  cerr.flush();

  while(!fileData.eof())
  {
      c=fileData.get();
      if(fileData.bad())
      {
          cerr << "reading input file \"" << filenameData << " error" << endl;
          exit(EXIT_FAILURE);
      }
      //remove all the white pieces of the string
      if(c!=' '&&c!='\r'&&c!='\n'&&c!='\t'&&c!=EOF)
      {
          data.push_back(c);
      }
  }
  cerr << "OK" << endl;
  fileData.close();

}

void readString(vector<string> &data, const string &filenameData)
{
  data.clear();

  ifstream fileData(filenameData.c_str(),ios::in);
  if (!fileData) {
    cerr << "can't open input file \"" << filenameData << "\"" << endl;
    exit(EXIT_FAILURE);
  }

  cerr << "reading \"" << filenameData << "\"...";
  cerr.flush();

  while(true)
  {
      string str;
      getline(fileData,str);
      if(fileData.eof())
        break;
      if(fileData.bad())
      {
          cerr << "reading input file \"" << filenameData << " error" << endl;
          exit(EXIT_FAILURE);
      }
      data.push_back(str);
  }
  cerr << "OK" << endl;
  fileData.close();

}

//modified by wjy read base string
void get_base_info(string &srcString, const string & baseFile, unsigned length)
{
	cout<<"reading base string..."<<flush;
	ifstream in(baseFile.c_str());
	if(!in){
		cout<<"reading base string fail! can't find the file: "<<baseFile<<endl;
		return;
	}
	while(srcString.length() < length)
	{
		string str;
		getline(in,str);
		srcString += str;
	}
	srcString.resize(length);
	cout<<"ok"<<endl;
}
